#ifndef VIEW_H
#define VIEW_H

#include <QGraphicsView>
#include <QGraphicsPixmapItem>

class ParticleItem : public QGraphicsRectItem
{
public:
    explicit ParticleItem(const QColor & color)
        : QGraphicsRectItem(0, 0, 2, 9) { xVel = 0; yVel = 0; setBrush(QBrush(color)); }
    int type() const
    { return QGraphicsItem::UserType + 1; }
    float xVel;
    float yVel;
};


class View : public QGraphicsView
{
    Q_OBJECT
public:
    explicit View(QWidget *parent = 0);

protected:
    bool viewportEvent(QEvent *event);

private slots:
    void loop();

private:
    void updatePositions();
    void particleSpawn(QPointF position);
    bool particleUpdateStep();

    int counter;
    bool loopIsRunning;
    bool exploding;

    QPixmap *arrowPixmap;

    QGraphicsScene scene;
    QVector<ParticleItem*> particles;

};

#endif // VIEW_H
